#include "GraphLib.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle
	.dw GraphLib
GraphLib:
	.db 8,"GraphLib"	;Write your own _vputps routine if you want
ShellTitle:
	.db "GraphLib demo!",0

ProgStart:
	call _flushallmenus
	call _runindicoff
	call _homeup
	call _clrScrn
	res appTextSave,(iy+appflags)
	res appAutoScroll,(iy+appflags)
	call RelocateLib
;	call CheckCheckSum		;Working on it now...

	ld hl,Tile
	ld bc,Sprites
	call DrawMap
	call Wait4User

	call ClrLCD
	ld hl,Logo
	ld bc,(256*119)+58
	call PutSpriteClip
	call Wait4User

	ld hl,Logo
	ld bc,(256*19)+39
	call PutSprite
	call Wait4User

	sub a
	ld (_penCol),a
	ld a,50
	ld (_penRow),a
	ld hl,Input
	call _vputs
	ld hl,_penCol
	inc (hl)
	ld b,3
	ld hl,Temp
	call TextIn

	ld hl,Temp
	sub a
	ld (_penCol),a
	ld (_penRow),a
	call _vputs
	call Wait4User

	ld hl,Title
	ld de,Text
	call DialogBox
	ld de,GraphLib_Text
	call GetVersion
	call Wait4User

	ld a,3
	ld (_curRow),a
	xor a
	ld (_curCol),a
	ld hl,GraphLib_Text
	call _putps
	call Wait4User
	call Wait1Sec
	set appTextSave,(iy+appflags)
	set appAutoScroll,(iy+appflags)
	ret
Input:
	.text "Initials?",0
Title:
	.text "GraphLib Demo v1.0"
Text:
	.text "by Patrick Wong"
Temp:
	.db "   ",0
Wait1Sec:
	ld b,200
W1S:
	halt
	djnz W1S
	ret
Wait4User:
	halt \ halt \ halt	;Super-Press bug fix
	halt \ halt \ halt
	halt \ halt \ halt
	halt \ halt \ halt
	ld a,%11111101	;load the bit mask so port 1 knows
			; which row to check
	out (1),a	;send out the bit mask 
	in a,(1)        ;get back the results
	bit 6,a         ;[alpha]'s position
	ret z
	jr Wait4User

RelocateLib:		;ROUTINE OPTIMIZED FOR SIZE!
;36 bytes
;178 t-states
;This excludes 'SorryLibNotFound' and the lib name
	ld hl,GraphLib-1			;hl->name of program

	rst 20h				;copy to OP1

	rst 10h				;_findsym

	jp c,SorryLibNotFound	;MUST HAVE STUPID LIB!
	call _ex_ahl_bde	;ROM calls all use AHL
	call _AHL_Plus_2_Pg3
	call _AHL_Plus_2_Pg3
	call _SET_ABS_SRC_ADDR

	sub a					;no absolute addressing now

	ld hl,$F700			;get data from here


	call _SET_ABS_DEST_ADDR


	ld hl,980	;number of bytes to save


	call _SET_MM_NUM_BYTES

	jp _MM_LDIR			;copy data and return


SorryLibNotFound:
	pop hl
	call _homeup
	ld hl,GraphLib
	call _putps
	call _newline
	ld hl,Uhoh
	call _puts
	jp _getkey
Uhoh:
	.db "was not found!!",0
Tile:
	.db 5,0,1,0,0,0,0,0,0,0,0,0,0,0,4,0
	.db 0,1,0,1,0,0,0,0,0,0,0,0,0,0,4,0
	.db 1,0,0,0,1,0,2,2,0,3,3,3,3,0,4,0
	.db 1,1,1,1,1,2,0,0,0,0,0,3,0,0,4,0
	.db 1,0,0,0,1,2,0,0,0,0,3,0,0,0,0,0
	.db 1,0,0,0,1,0,2,2,0,3,3,3,3,0,4,0
	.db 8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8
	.db 7,6,7,6,7,6,7,6,7,6,7,6,7,6,7,6
;Tribute to ACZ, who supplied me with a wealth of information!
.messAGE ACZ RULES!
Sprites:

0Sprite:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

1ewSprite:
	.db %00000000
	.db %00000000
	.db %00001100
	.db %00010110
	.db %01111111
	.db %01000001
	.db %01000001
	.db %00000010

xewSprite:
	.db %00000000
	.db %00111000
	.db %00100110
	.db %01000000
	.db %10000000
	.db %10000000
	.db %10000000
	.db %11110000

NxwSprite:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00111100
	.db %00000110
	.db %00011000
	.db %00100000
	.db %01111111

NexSprite:
	.db %00000000
	.db %00100000
	.db %00100000
	.db %00100000
	.db %00000000
	.db %00000000
	.db %00100000
	.db %00000000

Logo:
	.db %10010100
	.db %10000100
	.db %10010110
	.db %11010110
	.db %00000000
	.db %11111111
	.db %10000001
	.db %11111111

NewSxrite:
	.db %00000000
	.db %01111110
	.db %01011010
	.db %01111110
	.db %01111110
	.db %01011010
	.db %01111110
	.db %00000000

NewSpxite:
	.db %11111111
	.db %10000001
	.db %10100101
	.db %10000001
	.db %10000001
	.db %10100101
	.db %10000001
	.db %11111111

NewSprxte:
	.db %11111111
	.db %10000011
	.db %10111111
	.db %10100111
	.db %10100111
	.db %10111111
	.db %11111111
	.db %11111111


GraphLib_Text:		;TEMP_RAM
.end
